// VMware vMA Settings Manager Javascript and jQuery include file
// Copyright 2015-12-19 Nagios Enterprises, LLC


// I want all ajax calls to be performed synchronously
$.ajaxSetup({
	async: false
	}); // End $.ajaxSetup({


function vmwarevmasettingsmanager_ToggleMenu(a) {
	// Hide all menu elements 
   	$('.vmwarevmasettingsmanager-togglediv').hide(); 
	// Reset the last item that was selected
	$('.vmwarevmasettingsmanager-menuheading2').addClass("vmwarevmasettingsmanager-menuheading1").removeClass("vmwarevmasettingsmanager-menuheading2");
	// Show the selected menu element
	$('#' + a).show(); 
	// Style the currently selected menu item
	$('#id-' + a).addClass("vmwarevmasettingsmanager-menuheading2").removeClass("vmwarevmasettingsmanager-menuheading1");
	// Save the selected tab into the hidden input
	$('#id_vma_current_tab').val(a);
	} // End function vmwarevmasettingsmanager_ToggleMenu(a) {

	
function vmwarevmasettingsmanager_toggleMe(a) {
	$('#'+ a).slideToggle();
	} // End function vmwarevmasettingsmanager_toggleMe(a) {


function vmwarevmasettingsmanager_toggleAll(a) {
	var topics = a.split(':');
	var toggleAllText = $('#expand_collapse').text();
	for (var i=0;i<topics.length;i++) {
		if (toggleAllText == 'Expand All') {
			$('#' + topics[i]).show();
			} // End if (toggleAllText == 'Expand All') {
		else if (toggleAllText == 'Collapse All') {
			$('#' + topics[i]).hide();
			} // End else if (toggleAllText == 'Collapse All') {
		} // End for (var i=0;i<topics.length;i++) {
	if (toggleAllText == 'Expand All') {
		$('#expand_collapse').text('Collapse All');
		} // End if (toggleAllText == 'Expand All') {
	else if (toggleAllText == 'Collapse All') {
		$('#expand_collapse').text('Expand All');
		} // End else if (toggleAllText == 'Collapse All') {
	} // End function vmwarevmasettingsmanager_toggleAll(a) {


function vmwarevmasettingsmanagerToggleCheckbox(a) {
	//window.alert("value is: " + a);
	if ($('#'+ a).is(':checked')) {
		$(".vmwarevmasettingsmanager-checkbox").attr('checked', true);
		} // End if ($('#'+ a).is(':checked')) {
	else {
		$(".vmwarevmasettingsmanager-checkbox").attr('checked', false);
		} // End else {
	} // End function vmwarevmasettingsmanagerToggleCheckbox(a) {


function vmwarevmasettingsmanager_vma_host_select(vma_options) {
	//alert("vMA Options are: " + vma_options);

	// Get the vMA host selected
	var vma_host_address = $('#id_vma_host_select option:selected').val();
	//alert("vMA Host is: " + vma_host_address);

	// Define the DIV ID we are going to load
	var div_id = '#vmwarevmasettingsmanager-settings-display-host';
		
	if (vma_host_address == '') {
		// Hide the DIV
		$(div_id).hide();

		// No vMA Host was selected, show alert
		//alert('You did not select a vMA Host!');
		} // End if (vma_host_address == '') {
	else {
		// Get the vMA host name
		var vma_host_name = $('#id_vma_host_select option:selected').text();
		//alert("vMA Host Name is: " + vma_host_name);

		// Get the vMA Object Radio List
		var vmware_object_radio_list = $('#vmware_object_radio_list').val();
		//alert("vmware_object_radio_list: " + vmware_object_radio_list);

		// Load the DIV
		$(div_id).load('/nagiosxi/includes/components/vmwarevmasettingsmanager/vmwarevmasettingsmanager_misc.php?request=vma_host_select&vma_address=' + encodeURIComponent(vma_host_address) + '&vma_name=' + encodeURIComponent(vma_host_name) + '&vma_options=' + vma_options + '&vmware_object_radio_list=' + vmware_object_radio_list);
		// Show the DIV
		$(div_id).show();
		} // End else {
	} // End function vmwarevmasettingsmanager_vma_host_select() {



function vmwarevmasettingsmanager_vma_host_ping_test() {
	// Get the vMA host selected
	var vma_host_address = $('#id_vma_host_select option:selected').val();
	//alert("vMA Host is: " + vma_host_address);

	// Define the DIV ID we are going to load
	var div_id = '#vmwarevmasettingsmanager-settings-ping-test';

	// Hide the DIV
	$(div_id).hide();
	
	// Show the Throbber DIV
	$(div_id + '-throbber').show();
	
	// Load the DIV
	$(div_id).load('/nagiosxi/includes/components/vmwarevmasettingsmanager/vmwarevmasettingsmanager_misc.php?request=ping_test&vma_address=' + encodeURIComponent(vma_host_address));	

	// Hide the Throbber DIV
	$(div_id + '-throbber').hide();
	
	// Show the DIV
	$(div_id).show();
	} // End function vmwarevmasettingsmanager_vma_host_ping_test() {


function vmwarevmasettingsmanager_test(request) {
	switch (request) {
		case 'vma_host':
			// Get the vMA host selected
			var vma_host_address = $('#id_vma_host_test_radio:checked').val();
			//alert("vMA Host is: " + vma_host_address);

			if (vma_host_address == undefined) {
				alert('Please select a vMA host using the Test radio button');
				} // End if (vma_host_address == undefined) {
			else {
				// Define the DIV ID we are going to load
				var div_id = '#vmwarevmasettingsmanager-vma-host-test-results';

				// Hide the DIV
				$(div_id).hide();

				// Define the throbber DIV ID
				var div_id_throbber = '#vmwarevmasettingsmanager-vma-host-test-throbber';

				// Show the Throbber DIV
				$(div_id_throbber).show();

				// Get the test type
				var test_type = $('#id_vma_host_tests option:selected').val();

				// Perform the test
				switch (test_type) {
					case 'ping':
						// Load the DIV
						$(div_id).load('/nagiosxi/includes/components/vmwarevmasettingsmanager/vmwarevmasettingsmanager_misc.php?request=ping_test&address=' + encodeURIComponent(vma_host_address));
						break; // End case 'ping':

					case 'ssh_config':
						// Load the DIV
						$(div_id).load('/nagiosxi/includes/components/vmwarevmasettingsmanager/vmwarevmasettingsmanager_misc.php?request=ssh_config_test&address=' + encodeURIComponent(vma_host_address));
						break; // End case 'ssh_config':

					} // End switch (test_type) {
					
				// Hide the Throbber DIV
				$(div_id_throbber).hide();
				
				// Show the DIV
				$(div_id).show();
				} // End else {
			break; // End case 'vma_host':


		case 'vmware_host':
			// Get the vMA host selected
			var vma_host_address = $('#id_vma_host_select option:selected').val();
			//alert("vMA Host is: " + vma_host_address);

			// Get the VMware Object selected
			// The ID has periods so we need to escape them
			var vmware_object_id = ('#id_vmware_object_test_radio_' + vma_host_address + ':checked').replace( /(\.|\[|\])/g, "\\$1" );
			//alert("vmware_object_id is: " + vmware_object_id);
			var vmware_object_address = $(vmware_object_id).val();
			//alert("VMware Object is: " + vmware_object_address);

			if (vmware_object_address == undefined) {
				alert('Please select a VMware server using the Test radio button');
				} // End if (vmware_object_address == undefined) {
			else {
				// Define the DIV ID we are going to load
				var div_id = '#vmwarevmasettingsmanager-vmware-test-results';

				// Hide the DIV
				$(div_id).hide();

				// Define the throbber DIV ID
				var div_id_throbber = '#vmwarevmasettingsmanager-vmware-test-throbber';

				// Show the Throbber DIV
				$(div_id_throbber).show();

				// Get the test type
				var test_type = $('#id_vmware_tests option:selected').val();

				// Perform the test
				switch (test_type) {
					case 'ping':
						// Load the DIV
						$(div_id).load('/nagiosxi/includes/components/vmwarevmasettingsmanager/vmwarevmasettingsmanager_misc.php?request=ping_test_vmware&vma_host_address=' + encodeURIComponent(vma_host_address) + '&vmware_object_address=' + encodeURIComponent(vmware_object_address));
						break; // End case 'ping':

					case 'credentials':
						// Load the DIV
						$(div_id).load('/nagiosxi/includes/components/vmwarevmasettingsmanager/vmwarevmasettingsmanager_misc.php?request=credentials_test&vma_host_address=' + encodeURIComponent(vma_host_address) + '&vmware_object_address=' + encodeURIComponent(vmware_object_address));
						break; // End case 'credentials':

					} // End switch (test_type) {
					
				// Hide the Throbber DIV
				$(div_id_throbber).hide();
				
				// Show the DIV
				$(div_id).show();
				} // End else {
			break; // End case 'vmware_host':
		} // End switch (request) {
	} // End function vmwarevmasettingsmanager_test(request) {

