<?php  
// vmwarevmasettingsmanager_misc COMPONENT
//
// Copyright 2015-12-19 Nagios Enterprises, LCC
// 

require_once(dirname(__FILE__).'/../../common.inc.php');

/* initialization stuff */
pre_init();
/* start session */
init_session();
/* grab GET or POST variables */
grab_request_vars();
/* check prereqs */
check_prereqs();
/* check authentication */
check_authentication(false);

/* Define the Component Name */
$component_name = 'vmwarevmasettingsmanager';

/* Define the output */
$vmwarevmasettingsmanager_output = '';

/* Get the request passed to us */
$vmwarevmasettingsmanager_request = grab_request_var('request',false);

/* Process the request */
switch ($vmwarevmasettingsmanager_request) {
	case 'vma_host_select':
		/* Get the vMA Host Address */
		$vmwarevmasettingsmanager_host_address = urldecode(grab_request_var('vma_address',false));
		//print_r('$vmwarevmasettingsmanager_host_address: ' . $vmwarevmasettingsmanager_host_address . '<br/>');
		
		/* Get the vMA Host Name */
		$vmwarevmasettingsmanager_host_name = urldecode(grab_request_var('vma_name',false));
		//print_r('$vmwarevmasettingsmanager_host_name: ' . $vmwarevmasettingsmanager_host_name . '<br/>');

		/* Get the vMA Host Options */
		$vmwarevmasettingsmanager_host_options_serial = grab_request_var('vma_options',false);
		$vmwarevmasettingsmanager_host_options = unserialize(base64_decode($vmwarevmasettingsmanager_host_options_serial));
		//print_r('$vmwarevmasettingsmanager_host_options: ' . $vmwarevmasettingsmanager_host_options . '<br/>');
		
		$vma_host_options_counter = 0;

		/* Get the vMA Object Radio List */
		$vmware_object_radio_list_serial = grab_request_var('vmware_object_radio_list',false);
		$vmware_object_radio_list = unserialize(base64_decode($vmware_object_radio_list_serial));
		//print_r('$vmware_object_radio_list: ' . $vmware_object_radio_list . '<br/>');
		
		$vmwarevmasettingsmanager_output .= '<div class="sectionTitle">VMware Settings</div>';

		/* Check to see if options already exist */
		if (isset($vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address])) {
			if (isset($vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][0][0])) {
				/* Display the existing options */

				$vma_host_options_total = count($vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address]);
				//print_r('$vma_host_options_total: ' . $vma_host_options_total . '<br/>');

				/* Determining vMA Object Default Radio selection */
				$vmware_object_default_radio = grab_array_var($vmware_object_radio_list,$vmwarevmasettingsmanager_host_address,'');
				$vmware_object_default_radio_flag = 0;

				for ($c = 0; $c < $vma_host_options_total; $c++) {
					if ($vmware_object_default_radio == $vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][0]) {
						/* Set the flag */
						$vmware_object_default_radio_flag = 1;
						} /* End if ($vmware_object_default_radio == $vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][0]) { */
					} /* End for ($c = 0; $c < $vma_host_options_total; $c++) { */

				/* Defining vMA Object Default Radio if no default is set */
				if ($vmware_object_default_radio_flag == 0) {
					/* Using the first vMA host in the list */
					$vmware_object_default_radio = $vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][0][0];
					} /* End if ($vmware_object_default_radio_flag == 0) { */

				$vmwarevmasettingsmanager_output .= '
					The following is a list of VMware Servers you have previously defined.
					<div class="'.$component_name.'-spacer10"> </div>
					To <b>remove</b> VMware Server(s) from the list, <b>un-tick</b> the checkbox for that VMware Server and then click the <b>Apply Settings</b> button.
					<div class="'.$component_name.'-spacer10"> </div>
					The <b>Default</b> radio button is the VMware Server that will automatically be selected when using the VMware Virtualization wizard.
					<div class="'.$component_name.'-spacer10"> </div>
					
					<table>
					<thead><tr><th class="'.$component_name.'-width20"></th><th>Address of vCenter Server OR ESX(i) Host</th><th>Type</th><th>Default</th><th>Test</th></tr></thead>
					';
				for ($c = 0; $c < $vma_host_options_total; $c++) {
					$vmwarevmasettingsmanager_output .= '
						<tr>
						<td><input type="checkbox" name="vmware_object_checkbox_'.$vmwarevmasettingsmanager_host_address.'_'.$c.'" id="id_vmware_object_checkbox_'.$vmwarevmasettingsmanager_host_address.'_'.$c.'" class="'.$component_name.'-align-center" checked></td>
						<td><input type="text" name="vmware_object_address_'.$vmwarevmasettingsmanager_host_address.'_'.$c.'" id="id_vmware_object_address_'.$vmwarevmasettingsmanager_host_address.'_'.$c.'" value="'.$vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][0].'" class="'.$component_name.'-width250"/></td>
						<td>
							<select name="vmware_object_type_'.$vmwarevmasettingsmanager_host_address.'_'.$c.'" id="id_vmware_object_type_'.$vmwarevmasettingsmanager_host_address.'_'.$c.'" title="Folder Type">
								<option value="vcenter"'; if ($vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][1] == 'vcenter') $vmwarevmasettingsmanager_output .= ' selected'; $vmwarevmasettingsmanager_output .='>vCenter Server</option>
								<option value="esx"'; if ($vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][1] == 'esx') $vmwarevmasettingsmanager_output .= ' selected'; $vmwarevmasettingsmanager_output .='>ESX(i) Host</option>
							</select>
						</td>
						<td class="'.$component_name.'-align-center '.$component_name.'-width60"><input type="radio" name="vmware_object_default_radio_'.$vmwarevmasettingsmanager_host_address.'" value="'.$vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][0].'"'; if ($vmware_object_default_radio == $vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][0]) $vmwarevmasettingsmanager_output .= ' checked="checked"'; $vmwarevmasettingsmanager_output .= '/></td>
						<td class="'.$component_name.'-align-center"><input type="radio" name="vmware_object_test_radio_'.$vmwarevmasettingsmanager_host_address.'" id="id_vmware_object_test_radio_'.$vmwarevmasettingsmanager_host_address.'" value="'.$vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][$c][0].'"/></td>
						</tr>	
						';
					$vma_host_options_counter++;
					} /* End for ($c = 0; $c < $vma_host_options_total; $c++) { */

				$vmwarevmasettingsmanager_output .= '
					</table>

					<div class="'.$component_name.'-spacer20"> </div>

					To test a VMware server:
					<div class="'.$component_name.'-spacer10"> </div>
					<ul>
						<li>Select the server using the <b>Test</b> radio button to the right of the server</li>
						<li>Select the test <b>Type</b> from the drop down list below</li>
						<li>Click the <b>Perform VMware Test</b> button</li>
						<li>The results will be displayed below</li>
					</ul>
					
					<table>
						<tr>
							<td class="'.$component_name.'-width200">Select a VMware Test</td>
							<td>
								<select name="vmware_tests" id="id_vmware_tests" title="VMware Tests">
									<option value="ping" selected>Ping</option>
									<option value="credentials">Credentials</option>
								</select>
							</td>
						</tr>
						<tr>
							<td class="'.$component_name.'-width200">Click the button to execute the test</td>
							<td ><input type="button" onclick="'.$component_name.'_test(\'vmware_host\')" value="Perform VMware Test"></td>
						</tr>
					</table>

					
					<div id="'.$component_name.'-vmware-test-throbber" style="display:none">
						<div class="'.$component_name.'-spacer10"> </div>
						'.get_throbber_html().'
					</div>

					<div id="'.$component_name.'-vmware-test-results" style="display:none">
						<!-- This will be populated when a vma host test is performed -->
					</div>
					';
				} /* End if (isset($vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address][0][0])) { */
			} /* End if (isset($vmwarevmasettingsmanager_host_options[$vmwarevmasettingsmanager_host_address])) { */
		else {
			/* There are no existing options */
			$vmwarevmasettingsmanager_output .= '
				<div class="'.$component_name.'-spacer10"> </div>
				You have not configured any vCenter or ESX(i) host settings for this vMA, please add them as per below.
				<div class="'.$component_name.'-spacer10"> </div>
				'; 
			} # End else {

		/* Create fields to add host options */
		$vmwarevmasettingsmanager_output .= '
			<div class="sectionTitle">VMware Settings - Add</div>
			To <b>add</b> a VMware Server:
			<div class="'.$component_name.'-spacer5"> </div>
			<ul>
				<li><b>Tick</b> the checkbox</li>
				<li>
					Type the <b>IP Address</b> or <b>DNS Name</b> of the VMware Server
					<ul><li><i><b>Note:</b> DNS names are CaSe SeNsAtIvE</i></li></ul>
				</li>
				<li>Select the <b>Type</b> from the drop down list</li>
				<li>Click the <b>Apply Settings</b> button</li>
			</ul>

			<table>
				<tr><td class="'.$component_name.'-align-right"><b>Address Example:</b></td><td class="'.$component_name.'-width10"></td><td><i>192.168.1.211 or vCenter.domain.Local</i></td></tr>
			</table>

			<div class="'.$component_name.'-spacer20"> </div>
					
			<table>
				<thead><tr><th class="'.$component_name.'-width20"></th><th>Address of vCenter Server OR ESX(i) Host</th><th>Type</th></tr></thead>
				<tr>
					<td><input type="checkbox" name="vmware_object_checkbox_'.$vmwarevmasettingsmanager_host_address.'_'.$vma_host_options_counter.'" id="id_vmware_object_checkbox_'.$vmwarevmasettingsmanager_host_address.'_'.$vma_host_options_counter.'" class="'.$component_name.'-align-center"></td>
					<td><input type="text" name="vmware_object_address_'.$vmwarevmasettingsmanager_host_address.'_'.$vma_host_options_counter.'" id="id_vmware_object_address_'.$vmwarevmasettingsmanager_host_address.'_'.$vma_host_options_counter.'" class="'.$component_name.'-width250"/></td>
					<td>
						<select name="vmware_object_type_'.$vmwarevmasettingsmanager_host_address.'_'.$vma_host_options_counter.'" id="id_vmware_object_type_'.$vmwarevmasettingsmanager_host_address.'_'.$vma_host_options_counter.'" title="Folder Type">
							<option value="vcenter" selected>vCenter Server</option>
							<option value="esx">ESX(i) Host</option>
						</select>
					</td>
				</tr>
			</table>

			<div class="'.$component_name.'-spacer20"> </div>
			';

		$vmwarevmasettingsmanager_output .= '<input type="hidden" name="vma_host_options_counter" id="vma_host_options_counter" value="'.$vma_host_options_counter.'">';
			

		break; /* End case 'vma_host_select': */


	case 'ping_test':
		/* Get the address */
		$vmwarevmasettingsmanager_address = urldecode(grab_request_var('address',false));

		/* Define the test results array(); */
		$ping_test_results = array();
		
		/* Define the command */
		$ping_test_command = "ping -c 4 -w 4 $vmwarevmasettingsmanager_address 2>&1";

		/* Execute the command */
		exec($ping_test_command, $ping_test_results);

		/* Add the section title */
		$vmwarevmasettingsmanager_output .= '
			<div class="'.$component_name.'-spacer10"> </div>
			<div class="sectionTitle">Test Results</div>
			<div class="'.$component_name.'-spacer10"> </div>
			';

		foreach ($ping_test_results as $line) {
			$vmwarevmasettingsmanager_output .= $line . '<br/>';
			} /* End foreach ($ping_test_results as $line) { */

		$vmwarevmasettingsmanager_output .= '<div class="'.$component_name.'-spacer10"> </div>';
			
		break;  /* End case 'ping_test': */


	case 'ping_test_vmware':
		/* Get the vMA Host address */
		$vmwarevmasettingsmanager_vma_host_address = urldecode(grab_request_var('vma_host_address',false));

		/* Get the VMware Object address */
		$vmwarevmasettingsmanager_vmware_object_address = urldecode(grab_request_var('vmware_object_address',false));

		/* Define the test results array(); */
		$ping_test_results = array();
		
		/* Define the command */
		$ping_test_command = '/usr/local/nagios/libexec/check_by_ssh -E 1 -l vi-admin -H '.$vmwarevmasettingsmanager_vma_host_address.' -C \'ping -c 4 -w 4 '.$vmwarevmasettingsmanager_vmware_object_address.' 2>&1\'';

		/* Execute the command */
		exec($ping_test_command, $ping_test_results);

		/* Add the section title */
		$vmwarevmasettingsmanager_output .= '
			<div class="'.$component_name.'-spacer10"> </div>
			<div class="sectionTitle">Test Results</div>
			<div class="'.$component_name.'-spacer10"> </div>
			';

		foreach ($ping_test_results as $line) {
			$vmwarevmasettingsmanager_output .= $line . '<br/>';
			} /* End foreach ($ping_test_results as $line) { */

		$vmwarevmasettingsmanager_output .= '<div class="'.$component_name.'-spacer20"> </div>';
			
		break;  /* End case 'ping_test_vmware': */


	case 'ssh_config_test':
		/* Get the address */
		$vmwarevmasettingsmanager_address = urldecode(grab_request_var('address',false));

		/* Add the section title */
		$vmwarevmasettingsmanager_output .= '
			<div class="'.$component_name.'-spacer10"> </div>
			<div class="sectionTitle">Test Results</div>
			<div class="'.$component_name.'-spacer10"> </div>
			';

		/* Define the test results array(); */
		$ssh_not_exists_test_results = array();

		/* Define the command */
		$ssh_not_exists_test_command = "ls /var/www/.ssh 2>&1";

		/* Execute the command */
		exec($ssh_not_exists_test_command, $ssh_not_exists_test_results);
		
		$ssh_not_exists = 0;
		foreach ($ssh_not_exists_test_results as $line) {
			if ($line == 'ls: cannot access /var/www/.ssh: No such file or directory') {
				$ssh_not_exists = 1;
				} /* End if ($line == 'ls: cannot access /var/www/.ssh: No such file or directory') { */
			} /* End foreach ($ssh_not_exists_test_results as $line) { */

		if ($ssh_not_exists == 1) {
			$vmwarevmasettingsmanager_output .= '
				<b>Configuration Steps REQUIRED:</b>
				<div class="'.$component_name.'-spacer5"> </div>
				Establish an SSH session to this Nagios XI host as user <b>root</b>
				<div class="'.$component_name.'-spacer5"> </div>
				Type <b>mkdir /var/www/.ssh</b> and press <b>Enter</b><br/>
				<div class="'.$component_name.'-spacer5"> </div>
				Type <b>cp /home/nagios/.ssh/known_hosts /var/www/.ssh/</b> and press <b>Enter</b><br/>
				<div class="'.$component_name.'-spacer5"> </div>
				Type <b>cp /home/nagios/.ssh/id_dsa /var/www/.ssh/</b> and press <b>Enter</b><br/>
				<div class="'.$component_name.'-spacer5"> </div>
				Type <b>setfacl -R -m u:apache:r-x /var/www/.ssh/</b> and press <b>Enter</b><br/>
				<div class="'.$component_name.'-spacer5"> </div>
				Type <b>exit</b> and press <b>Enter</b>
				<div class="'.$component_name.'-spacer10"> </div>
				';
			} /* End if ($ssh_not_exists == 1) { */
		else {
			/* Now test to see if this is a known host */
			/* Define the known hosts array(); */
			$ssh_known_hosts = array();

			/* Get the known hosts */
			$ssh_known_hosts = file('/var/www/.ssh/known_hosts');
			
			$ssh_known_host = 0;

			/* See if the vMA host is in the known_hosts */
			foreach ($ssh_known_hosts as $line) {
				if (preg_match("/$vmwarevmasettingsmanager_address/", $line)) {
					$ssh_known_host = 1;
					} /* End if (preg_match("/$vmwarevmasettingsmanager_address/", $line)) { */
				} /* End foreach ($ssh_not_exists_test_results as $line) { */

			if ($ssh_known_host == 0) {
				$vmwarevmasettingsmanager_output .= '
					The vMA host '.$vmwarevmasettingsmanager_address.' is <b>NOT</b> in the known_hosts file.
					<div class="'.$component_name.'-spacer5"> </div>
					Please refer to the box293_check_vmware manual on how to configure this Nagios host to communicate with the vMA host.
					';
				} /* End if ($ssh_known_host == 0) { */
			else {
				/* Now test to see if check_by_ssh exists

				/* Define the test results array(); */
				$ssh_plugin_exists_test_results = array();

				/* Define the command */
				$ssh_plugin_exists_test_command = "ls /usr/local/nagios/libexec/check_by_ssh 2>&1";

				/* Execute the command */
				exec($ssh_plugin_exists_test_command, $ssh_plugin_exists_test_results);
				
				$ssh_plugin_exists = 0;

				/* Check the test results */
				foreach ($ssh_plugin_exists_test_results as $line) {
					if ($line == '/usr/local/nagios/libexec/check_by_ssh') {
						$ssh_plugin_exists = 1;
						} /* End if ($line == '/usr/local/nagios/libexec/check_by_ssh') { */
					} /* End foreach ($ssh_plugin_exists_test_results as $line) { */

				if ($ssh_plugin_exists == 0) {
					$vmwarevmasettingsmanager_output .= '
						The plugin <b>check_by_ssh</b> does not appear to exist in /usr/local/nagios/libexec/
						<div class="'.$component_name.'-spacer5"> </div>
						Please refer to the box293_check_vmware manual on how to install the Nagios Plugins on this Nagios host.
						';
					} /* End if ($ssh_plugin_exists == 0) { */
				else {
					/* Now test if we can establish an SSH session with the vMA host */

					/* Define the test results array(); */
					$ssh_connect_test_results = array();

					/* Define the command */
					$ssh_connect_test_command = 'ssh vi-admin@'.$vmwarevmasettingsmanager_address.' exit 2>&1';
					
					/* Execute the command */
					exec($ssh_connect_test_command, $ssh_connect_test_results);
					
					$ssh_connected = 0;
					$ssh_not_connected = '';
					foreach ($ssh_connect_test_results as $line) {
						//print_r($line . '<br/>');
						if ($line == 'Welcome to vSphere Management Assistant') {
							//print_r($line . '<br/>');
							$ssh_connected = 1;
							} /* End if ($line == 'Welcome to vSphere Management Assistant') { */

						if (strpos($line, 'Welcome to SUSE Linux Enterprise Server') === 0) {
							//print_r($line . '<br/>');
							$ssh_connected = 1;
							} /* End if (strpos($line, 'Welcome to SUSE Linux Enterprise Server') === 0) { */

						if ($line == 'Permission denied, please try again.') {
							//print_r($line . '<br/>');
							$ssh_connected = 0;
							} /* End if ($line == 'Permission denied, please try again.') { */
						
						$ssh_not_connected .= $line . '<br/>';
						
						} /* End foreach ($ssh_connect_test_results as $line) { */

					if ($ssh_connected == 0) {
						$vmwarevmasettingsmanager_output .= '
							There was an issue establishing an SSH session with the vMA host '.$vmwarevmasettingsmanager_address.'!
							<div class="'.$component_name.'-spacer5"> </div>
							The output is as follows:
							<div class="'.$component_name.'-spacer5"> </div>
							'.$ssh_not_connected.'
							<div class="'.$component_name.'-spacer10"> </div>
							Please refer to the box293_check_vmware manual on how to configure this Nagios host to communicate with the vMA host.
							';
						} /* End if ($ssh_connected == 0) { */
					else {
						/* Check if the plugin exists on the vMA host */

						/* Define the test results array(); */
						$ssh_box293_plugin_test_results = array();

						/* Define the command */
						$ssh_box293_plugin_test_command = '/usr/local/nagios/libexec/check_by_ssh -E 1 -l vi-admin -t 20 -H '.$vmwarevmasettingsmanager_address.' -C \'ls /home/vi-admin/box293_check_vmware.pl\'';
						
						/* Execute the command */
						exec($ssh_box293_plugin_test_command, $ssh_box293_plugin_test_results);
						
						$ssh_box293_plugin_exists = 0;
						foreach ($ssh_box293_plugin_test_results as $line) {
							//$vmwarevmasettingsmanager_output .= $line . '<br/>';
							if ($line == '/home/vi-admin/box293_check_vmware.pl') {
								$ssh_box293_plugin_exists = 1;
								} /* End if ($line == '/home/vi-admin/box293_check_vmware.pl') { */
							} /* End foreach ($ssh_box293_plugin_test_results as $line) { */

						if ($ssh_box293_plugin_exists == 0) {
							$vmwarevmasettingsmanager_output .= '
								Could not find the <b>box293_check_vmware</b> plugin on the vMA host '.$vmwarevmasettingsmanager_address.'!
								<div class="'.$component_name.'-spacer10"> </div>
								Please refer to the box293_check_vmware manual on how to add the box293_check_vmware plugin to the vMA host.
								';
							} /* End if ($ssh_box293_plugin_exists == 0) { */
						else {
							$vmwarevmasettingsmanager_output .= 'SSH Configuration is correct!';
							} /* End else { */
						} /* End else { */
					} /* End else { */
				} /* End else { */
			} /* End else { */

		$vmwarevmasettingsmanager_output .= '<div class="'.$component_name.'-spacer20"> </div>';
		
		break;  /* End case 'ssh_config_test': */


	case 'credentials_test':
		/* Get the vMA Host address */
		$vmwarevmasettingsmanager_vma_host_address = urldecode(grab_request_var('vma_host_address',false));

		/* Get the VMware Object address */
		$vmwarevmasettingsmanager_vmware_object_address = urldecode(grab_request_var('vmware_object_address',false));

		/* Define the test results array(); */
		$credentials_test_results = array();
		
		/* Define the command */
		$credentials_test_command = '/usr/local/nagios/libexec/check_by_ssh -E 1 -l vi-admin -H '.$vmwarevmasettingsmanager_vma_host_address.' -C \'~/box293_check_vmware.pl --server '.$vmwarevmasettingsmanager_vmware_object_address.' --version\'';

		/* Execute the command */
		exec($credentials_test_command, $credentials_test_results);

		/* Add the section title */
		$vmwarevmasettingsmanager_output .= '
			<div class="'.$component_name.'-spacer10"> </div>
			<div class="sectionTitle">Test Results</div>
			<div class="'.$component_name.'-spacer10"> </div>
			';

		$credentials_ok = 0;
		if (count($credentials_test_results) == 1) {
			if (strlen($credentials_test_results[0]) == 39) {
				$credentials_ok = 1;
				$vmwarevmasettingsmanager_output .= '
					Credentials tested OK!
					';
				} /* End if (strlen($credentials_test_results[0]) == 39) { */
			} /* End if (count($credentials_test_results) == 1) { */

		if ($credentials_ok == 0) {
			$vmwarevmasettingsmanager_output .= '
				Credentials test did not perform as expected on the vMA host '.$vmwarevmasettingsmanager_vma_host_address.' connecting to the VMware server '.$vmwarevmasettingsmanager_vmware_object_address.'!
				<div class="'.$component_name.'-spacer10"> </div>
				Please refer to the box293_check_vmware manual on how to configure the credentials on the vMA host.
				<div class="'.$component_name.'-spacer10"> </div>
				Output from command:
				<div class="'.$component_name.'-spacer10"> </div>
				';
			foreach ($credentials_test_results as $line) {
				$vmwarevmasettingsmanager_output .= $line . '<br/>';
				} /* End foreach ($credentials_test_results as $line) { */
			} /* End if ($credentials_ok == 0) { */
		
		$vmwarevmasettingsmanager_output .= '<div class="'.$component_name.'-spacer20"> </div>';

		break; /* End case 'credentials_test': */

	} # End switch ($vmwarevmasettingsmanager_request) {


// Display the Output
print $vmwarevmasettingsmanager_output;



?>
